;****************************************************************************
;
;Hauptprogramm ab Adresse 0200h:
;Ein schlichter Binrzhler, der den Zhlwert auf die Adresse F000h ausgibt
;
;IRQ ab Adresse  0240h
;sichert den aktuellen Zhlerstand und zeigt dreimal ein Lauflicht von rechts
;nach links
;
;NMI ab Adresse  0280h
;sichert den aktuellen Zhlerstand und zeigt dreimal ein Lauflicht von links
;nach rechts
;
;****************************************************************************

        .org $0200   ; Programm startet hinter Stack


        lda #00      ; ACCU auf Null
loop:   cli          ; ermgliche IRQ
        ina          ; erhhe ACCU um 1 (Binrzhler)
        sta $f000    ; ACCU auf Schreib-Port
        jmp loop     ; bis zum Erbrechen


        .org $0240   ; Platziere IRQ-Routine genau auf eingestellten Vektor

int:    pha          ; rette aktuellen Binr-Zhlerstand in ACCU auf Stack
        ldy #03      ; Anzeigenzhlerladen (3 mal Anzeigen)
rowint: ldx #08      ; Schiebezhler laden (8 mal schieben pro Anzeige)
        lda #00      ; INT-Anzeige startet mit Null im ACCU
colint: sec          ; setze Carry
        rol          ; und ziehe es beim Linksschieben in die Anzeige
        sta $f000    ; Ausgabe auf Schreib-Port
        dex          ; vermindere Schiebezhler
        bne colint   ; Sprung wenn noch nicht alle 8 Datenleitungen an
        dey          ; verminder Anzeigenzhler
        bne rowint   ; Sprung wenn INT-Anzeige noch nicht 3* angezeigt wurde
        pla          ; hole alten Binr-Zhlerstand in ACCU
        rti          ; zurck zum Hauptprogramm


        .org $0280   ; Platziere NMI-Routine genau auf eingestellten Vektor

nmi:    pha          ; rette aktuellen Zhlerstand wenn Hauptprogrammunterbrechung
        phx          ; rette aktuellen Anzeigenzhlerstand bei INT-Routinenunterbrechung
        phy          ; rette aktuellen Schiebezhlerstand bei INT-Routinenunterbrechnung
        ldy #03      ; Anzeigenzhlerladen (3 mal Anzeigen)
rownmi: ldx #08      ; Schiebezhler laden (8 mal schieben pro Anzeige)
        lda #00      ; NMI-Anzeige startet mit Null im ACCU
colnmi: sec          ; setze Carry
        ror          ; und ziehe es beim Rechtsschieben in die Anzeige
        sta $f000    ; Ausgabe auf Schreib-Port
        dex          ; vermindere Schiebezhler
        bne colnmi   ; Sprung wenn noch nicht alle 8 Datenleitungen an
        dey          ; verminder Anzeigenzhler
        bne rownmi   ; Sprung wenn INT-Anzeige noch nicht 3* angezeigt wurde
        ply          ; hole alten Schiebzhlerstand
        plx          ; hole alten Anzeigenzhler
        pla          ; hole alten Binr-Zhlerstand in ACCU
        rti          ; zurck zum Hauptprogramm bzw. Int-Routine

